=== modified file 'src/com/goldencode/p2j/ui/client/gui/DropDownGuiImpl.java'
--- src/com/goldencode/p2j/ui/client/gui/DropDownGuiImpl.java	2019-04-04 17:03:54 +0000
+++ src/com/goldencode/p2j/ui/client/gui/DropDownGuiImpl.java	2020-02-25 16:54:43 +0000
@@ -2,7 +2,7 @@
 ** Module   : DropDownGuiImpl.java
 ** Abstract : Drop down box for combo-box GUI specific implementation.
 **
-** Copyright (c) 2015-2019, Golden Code Development Corporation.
+** Copyright (c) 2015-2020, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- ---------------------------------Description----------------------------------
 ** 001 EVL 20150428 Created initial version.
@@ -34,6 +34,7 @@
 ** 020 OM  20170320 Added support for Themes.
 ** 021 CA  20180502 Fixed COLOR option, COLOR statement and other color-related issues.
 ** 022 EVL 20190403 Adding implementation support for AUTO-COMPLETION attribute.
+** 023 SBI 20200225 Reused the common code.
 */
 /*
 ** This program is free software: you can redistribute it and/or modify
@@ -95,7 +96,6 @@
 import com.goldencode.p2j.ui.client.*;
 import com.goldencode.p2j.ui.client.event.*;
 import com.goldencode.p2j.ui.client.gui.driver.*;
-import com.goldencode.p2j.ui.client.gui.theme.*;
 import com.goldencode.p2j.ui.client.model.*;
 import com.goldencode.p2j.ui.client.ScrollBar.Bars;
 
@@ -197,48 +197,8 @@
       
       // set list width, account for the border
       list.setColumns(width() - scrollPaneGui.getBorder().insets().widthDelta());
-
-      // start GUI specifics
-      // get the absolute coord of the combo-box this drop-down belongs to
-      NativePoint cbbPhysLoc = parent.screenPhysicalLocation();
-      
-      // set the coordinates relative to parent combo-box widget
-      //
-      // The combo-box and drop-down both belong to different frames. The parent frame
-      // for drop-down is border-less and header-less invisible frame located inside Window
-      // workspaces. So when we get the physical location of the combo-box we have location
-      // related to frame the combo-box belongs to. If we use this coords to place drop-down we
-      // have XY shift according to combo-box's frame placement and decoration. That's why we can
-      // not just use combo-box location plus combo box height here.
-      //
-      // The approach is to get absolute coordinates of the combo-box, get the coordinate of the
-      // workspace, subtract second from first and add the combo-box height.
-      
-      // the combo-box height plus some extra pixels to match 4GL look and feel
-      int cbbHeightPlus = screen().coordinates().heightToNative(parent.height()) + 
-                          ThemeManager.getCurrentTheme().getComboBoxDropDownOffset();
-      NativePoint ddPhysLoc = new NativePoint(cbbPhysLoc.x, cbbPhysLoc.y);
-      
-      // check if the drop-down will fit the current display dimension
-      // get combo-box window ID
-      int mainWndId = getComboBox().topLevelWindow().getId().asInt();
-      // get combo-box absolute coordinates
-      NativePoint cbbDispLoc = parent.displayPhysicalLocation();
-      // total screen and drop-down dimension
-      NativeRectangle nr = gd.getDisplayBounds(mainWndId);
-      NativeDimension nDim = physicalDimension();
-      
-      // calculate final drop-down y coordinate (to display the full list above or below the
-      // parent) based on space available, but the preference will be below if possible
-      if (cbbDispLoc.y + cbbHeightPlus + nDim.height > nr.bottom() &&
-          cbbDispLoc.y - nDim.height > nr.top())
-      {
-         ddPhysLoc.y -= nDim.height;
-      }
-      else
-      {
-         ddPhysLoc.y += cbbHeightPlus;
-      }
+      
+      NativePoint ddPhysLoc = UiUtils.getDropDownPhysicalLocation(parent, this, gd);
       
       // set up drop-down location below or above the combo-box depending on above calculations
       setPhysicalLocation(ddPhysLoc.x, ddPhysLoc.y);

=== modified file 'src/com/goldencode/p2j/ui/client/gui/GuiColorResolver.java'
--- src/com/goldencode/p2j/ui/client/gui/GuiColorResolver.java	2018-05-03 15:25:10 +0000
+++ src/com/goldencode/p2j/ui/client/gui/GuiColorResolver.java	2020-02-25 16:53:34 +0000
@@ -2,7 +2,7 @@
 ** Module   : GuiColorResolver.java
 ** Abstract : GUI widget color resolver
 **
-** Copyright (c) 2014-2018, Golden Code Development Corporation.
+** Copyright (c) 2014-2020, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- ---------------------------------Description---------------------------------
 ** 001 MAG 20141022 Created initial version.
@@ -14,6 +14,7 @@
 ** 006 OM  20170707 Rectangles do not inherit parent frame color.
 ** 007 CA  20171111 Added WIDGET:BGCOLOR-RGB and WIDGET:FGCOLOR-RGB FWD extension attributes
 ** 008 CA  20180502 Fixed COLOR option, COLOR statement and other color-related issues.
+** 009 SBI 20200225 Added Calendar widget support.
 */
 
 /*
@@ -182,6 +183,7 @@
                     !(config instanceof BrowseConfig && config.enabled  ||
                       config instanceof ComboBoxConfig && config.enabled||
                       config instanceof FillInConfig && config.enabled  ||
+                      config instanceof CalendarConfig ||
                       config instanceof RectangleConfig)))
                {
                   // disabled browses and rectangles do not inherit implicit frame color
@@ -225,6 +227,7 @@
                    (frame.config().fgcolor != -1 ||
                     !(config instanceof BrowseConfig && config.enabled   ||
                       config instanceof ComboBoxConfig && config.enabled ||
+                      config instanceof CalendarConfig ||
                       config instanceof RectangleConfig)))
                {
                   // disabled browses and rectangles do not inherit implicit frame color

=== modified file 'src/com/goldencode/p2j/ui/client/gui/GuiWidgetFactory.java'
--- src/com/goldencode/p2j/ui/client/gui/GuiWidgetFactory.java	2019-11-19 14:11:39 +0000
+++ src/com/goldencode/p2j/ui/client/gui/GuiWidgetFactory.java	2020-02-25 16:52:42 +0000
@@ -2,7 +2,7 @@
 ** Module   : GuiWidgetFactory.java
 ** Abstract : a factory for GUI widgets
 **
-** Copyright (c) 2014-2019, Golden Code Development Corporation.
+** Copyright (c) 2014-2020, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- ---------------------------------Description---------------------------------
 ** 001 MAG 20140521 Created initial version.
@@ -53,6 +53,7 @@
 **                  it the base for the TREELIST widget.
 ** 034 MAG 20191106 Initial implementation of IMAGE-LIST widget.
 ** 035 MAG 20191003 Adding PROGRESS-BAR widget related changes.
+** 036 SBI 20200225 Added Calendar widget support.
 */
 
 /*
@@ -175,6 +176,7 @@
       classMap.put(HtmlBrowserGuiImpl.class, HtmlBrowserGuiImpl.class);
       classMap.put(ImageListGuiImpl.class, ImageListGuiImpl.class);
       classMap.put(ProgressBarGuiImpl.class, ProgressBarGuiImpl.class);
+      classMap.put(CalendarGuiImpl.class, CalendarGuiImpl.class);
    }
    
    /**

=== modified file 'src/com/goldencode/p2j/ui/client/gui/ProgressBarGui.java'
--- src/com/goldencode/p2j/ui/client/gui/ProgressBarGui.java	2019-12-13 08:58:45 +0000
+++ src/com/goldencode/p2j/ui/client/gui/ProgressBarGui.java	2020-02-25 16:51:37 +0000
@@ -2,10 +2,11 @@
 ** Module   : ProgressBarGui.java
 ** Abstract : PROGRESS-BAR widget interface.
 **
-** Copyright (c) 2019, Golden Code Development Corporation.
+** Copyright (c) 2019-2020, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- ---------------------------------Description---------------------------------
 ** 001 MAG 20191011 Created initial version.
+** 002 SBI 20200225 Reused the common code.
 */
 
 /*
@@ -86,25 +87,6 @@
    public static final int CC_SCROLLING_STANDARD = 0;
    public static final int CC_SCROLLING_SMOOTH   = 1;
    
-   /* Mouse Pointer */
-   public static final int CC_DEFAULT          = 0;
-   public static final int CC_ARROW            = 1;
-   public static final int CC_CROSS            = 2;
-   public static final int CC_IBEAM            = 3;
-   public static final int CC_ICON             = 4;
-   public static final int CC_SIZE             = 5;
-   public static final int CC_SIZE_NESW        = 6;
-   public static final int CC_SIZE_NS          = 7;
-   public static final int CC_SIZE_NWSE        = 8;
-   public static final int CC_SIZE_EW          = 9;
-   public static final int CC_UP_ARROW        = 10;
-   public static final int CC_HOURGLASS       = 11;
-   public static final int CC_NO_DROP         = 12;
-   public static final int CC_ARROW_HOURGLASS = 13;
-   public static final int CC_ARROW_QUESTION  = 14;
-   public static final int CC_SIZE_ALL        = 15;
-   public static final int CC_CUSTOM          = 99;
-
    /**
     * If the method returns <code>true</code> the widget should be represented with 3D visuals.
     */

=== modified file 'src/com/goldencode/p2j/ui/client/gui/ProgressBarGuiImpl.java'
--- src/com/goldencode/p2j/ui/client/gui/ProgressBarGuiImpl.java	2019-12-09 12:20:19 +0000
+++ src/com/goldencode/p2j/ui/client/gui/ProgressBarGuiImpl.java	2020-02-25 16:50:52 +0000
@@ -2,10 +2,11 @@
 ** Module   : ProgressBarGuiImpl.java
 ** Abstract : GUI implementation of the PROGRESS-BAR widget.
 **
-** Copyright (c) 2019, Golden Code Development Corporation.
+** Copyright (c) 2019-2020, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- ---------------------------------Description---------------------------------
 ** 001 MAG 20191003 Created initial version.
+** 002 SBI 20200225 Reused the common code.
 */
 
 /*
@@ -65,6 +66,7 @@
 
 import static com.goldencode.p2j.ui.client.gui.OcxMouseHelper.*;
 import static com.goldencode.p2j.ui.client.gui.OleDragDropHelper.*;
+import static com.goldencode.p2j.ui.WidgetConfigExt.*;
 
 import java.awt.event.MouseEvent;
 

=== modified file 'src/com/goldencode/p2j/ui/client/gui/ToggleBoxGuiImpl.java'
--- src/com/goldencode/p2j/ui/client/gui/ToggleBoxGuiImpl.java	2019-05-02 11:36:36 +0000
+++ src/com/goldencode/p2j/ui/client/gui/ToggleBoxGuiImpl.java	2020-02-25 16:49:16 +0000
@@ -2,7 +2,7 @@
 ** Module   : ToggleBoxGuiImpl.java
 ** Abstract : GUI toggle-box implementation
 **
-** Copyright (c) 2014-2019, Golden Code Development Corporation.
+** Copyright (c) 2014-2020, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- ---------------------------------Description---------------------------------
 ** 001 VIG 20150210 Initial version.
@@ -40,6 +40,7 @@
 ** 024 EVL 20190408 Fixed issue with label first letter underlining when it should not be.
 ** 025 HC  20190418 Reverted "The widget should emit one time VALUE-CHANGED when initial value is set.".
 ** 026 SVL 20190502 Support for RETURN key for browsed toggle-boxes.
+** 027 SBI 20200225 Added setColorResolver.
 */
 /*
 ** This program is free software: you can redistribute it and/or modify
@@ -265,8 +266,12 @@
    @Override
    public void draw()
    {
-      int bgColor = isThreeD() ? SysColor.COLOR_3DFACE : SysColor.COLOR_FILLIN_BG;
-      gc = new GuiColorResolver(gd, config, bgColor, SysColor.COLOR_BTNTEXT);
+      if (gc == null)
+      {
+         int bgColor = isThreeD() ? SysColor.COLOR_3DFACE : SysColor.COLOR_FILLIN_BG;
+         
+         setColorResolver(new GuiColorResolver(gd, config, bgColor, SysColor.COLOR_BTNTEXT));
+      }
       
       // determine colors to use
       gc.colors();
@@ -282,6 +287,17 @@
             ThemeManager.getCurrentTheme().drawToggleBox(
                   this, gd, gc, gf, 0, 0, d.width, d.height, pressed, false));
    }
+   
+   /**
+    * Sets the color resolver.
+    * 
+    * @param    resolver
+    *           The color revolver
+    */
+   public void setColorResolver(GuiColorResolver resolver)
+   {
+      gc = resolver;
+   }
 
    /**
     * Recalculates WIDTH attribute using actual label.

=== modified file 'src/com/goldencode/p2j/ui/client/gui/driver/swing/SwingEmulatedWindow.java'
--- src/com/goldencode/p2j/ui/client/gui/driver/swing/SwingEmulatedWindow.java	2019-06-05 04:50:19 +0000
+++ src/com/goldencode/p2j/ui/client/gui/driver/swing/SwingEmulatedWindow.java	2020-02-25 16:47:35 +0000
@@ -2,7 +2,7 @@
 ** Module   : SwingEmulatedWindow.java
 ** Abstract : core GUI renderer for AWT/Swing client
 **
-** Copyright (c) 2014-2019, Golden Code Development Corporation.
+** Copyright (c) 2014-2020, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- ---------------------------------Description---------------------------------
 ** 001 MAG 20140508 First version.
@@ -143,6 +143,7 @@
 **     CA  20190226 Fixed layoutParagraphWorker when empty lines are involved.
 ** 066 AVK 20190527 Fixed an NPE in drawStringCenteredWithinBox, which was called with a null
 **                  text, for a button without an explicit label set (bug #4078).
+** 067 SBI 20200225 Fixed DRAW_STRING_WITHIN_BOX drawing operation.
 */
 
 /*
@@ -1768,7 +1769,7 @@
       
       int x = ps.x + (ps.width - nativeWidth) /2;
       
-      for (int k = 0; k < numberIndices / 2; k++)
+      for (int k = 0; k < numberIndices; k+=2)
       {
          int delta;
          

=== modified file 'src/com/goldencode/p2j/ui/client/gui/driver/web/res/p2j.screen.js'
--- src/com/goldencode/p2j/ui/client/gui/driver/web/res/p2j.screen.js	2019-12-18 22:26:05 +0000
+++ src/com/goldencode/p2j/ui/client/gui/driver/web/res/p2j.screen.js	2020-02-25 16:46:36 +0000
@@ -2,7 +2,7 @@
 ** Module   : p2j.screen.js
 ** Abstract : GUI-specific screen management
 **
-** Copyright (c) 2014-2019, Golden Code Development Corporation.
+** Copyright (c) 2014-2020, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- ------------------------------Description----------------------------------
 ** 001 GES 20150325 Created GUI version from ChUI version. Right now it is not functional.
@@ -102,6 +102,7 @@
 ** 043 HC  20191120 Extended SYSTEM-DIALOG GET-FILE with AT-WEB-BROWSER option.
 **     HC  20191126 Implemented RESIZE attribute for DIALOG-BOX. This is an extension to 4GL.
 **     HC  20191218 Fixed wrong coordinates in the mouse move MsgBlaster event.
+** 044 SBI 20200225 Fixed DRAW_STRING_WITHIN_BOX drawing operation.
 */
 
 /*
@@ -2272,7 +2273,7 @@
                
                x = xPosition + (width - nativeWidth)/2;
                y = yPosition;
-               for (var k = 0; k < numberIndices / 2; k++)
+               for (var k = 0; k < numberIndices; k += 2)
                {
                   var delta;
                   

=== modified file 'src/com/goldencode/p2j/ui/client/gui/theme/ClassicTheme.java'
--- src/com/goldencode/p2j/ui/client/gui/theme/ClassicTheme.java	2020-01-29 14:38:53 +0000
+++ src/com/goldencode/p2j/ui/client/gui/theme/ClassicTheme.java	2020-02-25 16:44:22 +0000
@@ -2,7 +2,7 @@
 ** Module   : ClassicTheme.java
 ** Abstract : Windows Classic theme handler. 
 **
-** Copyright (c) 2017-2019, Golden Code Development Corporation.
+** Copyright (c) 2017-2020, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- ---------------------------------Description---------------------------------
 ** 001 OM  20170224 First version.
@@ -69,6 +69,7 @@
 ** 038 HC  20190614 Implemented IMAGELIST attribute for TREEVIEW and TREELIST widgets.
 ** 039 MAG 20191011 Added ProgresBar widget draw methods. 
 ** 040 MAG 20191129 Draw TabSet widget.
+** 041 SBI 20200225 Implemented look and feel helpers for the calendar widget.
 */
 
 /*
@@ -139,6 +140,7 @@
 import com.goldencode.p2j.ui.client.gui.theme.Theme.TextLookAndFeel.*;
 import com.goldencode.p2j.ui.client.widget.*;
 import com.goldencode.p2j.util.*;
+
 import org.apache.commons.io.*;
 
 import java.awt.*;
@@ -7616,4 +7618,225 @@
          }
       }
    }
+   
+   /**
+    * Sets DOWN arrow images for the given button.
+    * 
+    * @param    button
+    *           The given button
+    */
+   @Override
+   public void setDownArrowImages(ButtonGuiImpl button)
+   {
+      setButtonImages(button, "sb-arr-en-down", "sb-arr-dis-down", "classic",
+               COMBO_BOX_BUTTON_SIZE, COMBO_BOX_BUTTON_SIZE);
+   }
+
+   /**
+    * Sets LEFT arrow images for the given button.
+    * 
+    * @param    button
+    *           The given button
+    */
+   @Override
+   public void setLeftArrowImages(ButtonGuiImpl button)
+   {
+      setButtonImages(button, "sb-arr-en-left", "sb-arr-dis-left", "classic",
+               COMBO_BOX_BUTTON_SIZE, COMBO_BOX_BUTTON_SIZE);
+   }
+
+   /**
+    * Sets RIGHT arrow images for the given button.
+    * 
+    * @param    button
+    *           The given button
+    */
+   @Override
+   public void setRightArrowImages(ButtonGuiImpl button)
+   {
+      setButtonImages(button, "sb-arr-en-right", "sb-arr-dis-right", "classic",
+               COMBO_BOX_BUTTON_SIZE, COMBO_BOX_BUTTON_SIZE);
+   }
+
+   /**
+    * Sets UP arrow images for the given button.
+    * 
+    * @param    button
+    *           The given button
+    */
+   @Override
+   public void setUpArrowImages(ButtonGuiImpl button)
+   {
+      setButtonImages(button, "sb-arr-en-up", "sb-arr-dis-up", "classic",
+               COMBO_BOX_BUTTON_SIZE, COMBO_BOX_BUTTON_SIZE);
+   }
+   
+   /**
+    * Gets the background color index for the selected day of the calendar popup.
+    * 
+    * @return   The background color index for the selected day
+    */
+   @Override
+   public int getSelectedDayBackgroundColor()
+   {
+      return SysColor.COLOR_HOTLIGHT;
+   }
+   
+   /**
+    * Gets the foreground color index for the selected day of the calendar popup.
+    * 
+    * @return   The foreground color index for the selected day
+    */
+   @Override
+   public int getSelectedDayForegroundColor()
+   {
+      return SysColor.COLOR_HIGHLIGHTTEXT;
+   }
+   
+   /**
+    * Gets the background color index for the title of the calendar popup.
+    * 
+    * @return   The background color index for the title
+    */
+   @Override
+   public int getCalendarTitleBackgroundColor()
+   {
+      return SysColor.COLOR_ACTIVECAPTION;
+   }
+   
+   /**
+    * Gets the foreground color index for the title of the calendar popup.
+    * 
+    * @return   The foreground color index for the title
+    */
+   @Override
+   public int getCalendarTitleForegroundColor()
+   {
+      return SysColor.COLOR_CAPTIONTEXT;
+   }
+   
+   /**
+    * Gets the background color index for the trailing days around the current month 
+    * of the calendar popup.
+    * 
+    * @return   The background color index for the trailing days
+    */
+   @Override
+   public int getCalendarTrailingBackgroundColor()
+   {
+      return SysColor.COLOR_FILLIN_BG;
+   }
+   
+   /**
+    * Gets the foreground color index for the trailing days around the current month 
+    * of the calendar popup.
+    * 
+    * @return   The foreground color index for the trailing days
+    */
+   @Override
+   public int getCalendarTrailingForegroundColor()
+   {
+      return SysColor.COLOR_INACTIVECAPTIONTEXT;
+   }
+   
+   /**
+    * Gets the background color index for the body of the calendar popup.
+    * 
+    * @return   The background color index for the body
+    */
+   @Override
+   public int getCalendarBodyBackgroundColor()
+   {
+      return SysColor.COLOR_FILLIN_BG;
+   }
+   
+   /**
+    * Gets the foreground color index for the body of the calendar popup.
+    * 
+    * @return   The foreground color index for the body
+    */
+   @Override
+   public int getCalendarBodyForegroundColor()
+   {
+      return SysColor.COLOR_FILLIN_FG;
+   }
+   
+   /**
+    * Prepares the target map of images for up, down and disabled states of a button.
+    * 
+    * @param    enableImage
+    *           The resource name for the enabled button
+    * @param    disableImage
+    *           The resource name for the disabled button
+    * @param    location
+    *           The resource directory
+    * @param    width
+    *           The image width in pixels
+    * @param    height
+    *           The image height in pixels
+    * 
+    * @return   The target images
+    */
+   public static Map<Integer, ImageWrapper> getImages(String enableImage,
+                                                      String disableImage,
+                                                      String location,
+                                                      int width,
+                                                      int height)
+   {
+      ImageWrapper imgButtEn = VectorGraphicsHelper.getScalableImage(enableImage, location,
+               width, height);
+      ImageWrapper imgButtDis = VectorGraphicsHelper.getScalableImage(disableImage, location,
+               width, height);
+
+      Map<Integer, ImageWrapper> images = new HashMap<>(3);
+      
+      images.put(ButtonConfig.IMAGE_DOWN, imgButtEn);
+      images.put(ButtonConfig.IMAGE_UP, imgButtEn);
+      images.put(ButtonConfig.IMAGE_INS, imgButtDis);
+      
+      return images;
+   }
+   
+   /**
+    * Assigns the target images for the given button.
+    * 
+    * @param    button
+    *           The image consumer
+    * @param    enableImage
+    *           The resource name for the enabled button
+    * @param    disableImage
+    *           The resource name for the disabled button
+    * @param    location
+    *           The resource directory
+    * @param    width
+    *           The image width in pixels
+    * @param    height
+    *           The image height in pixels
+    */
+   public static void setButtonImages(ButtonGuiImpl button,
+                                      String enableImage,
+                                      String disableImage,
+                                      String location,
+                                      int width,
+                                      int height)
+   {
+      Map<Integer, ImageWrapper> images = getImages(enableImage, disableImage, location, width, height);
+      
+      button.config().imgDownDef.heightPixels = height;
+      button.config().imgDownDef.widthPixels = width;
+      button.config().imgDownDef.name = enableImage;
+      
+      button.config().imgUpDef.heightPixels = height;
+      button.config().imgUpDef.widthPixels = width;
+      button.config().imgUpDef.name = enableImage;
+      
+      button.config().imgInsDef.heightPixels = height;
+      button.config().imgInsDef.widthPixels = width;
+      button.config().imgInsDef.name = disableImage;
+      
+      
+      button.setImage(ButtonConfig.IMAGE_UP, images.get(ButtonConfig.IMAGE_UP));
+      button.setImage(ButtonConfig.IMAGE_DOWN, images.get(ButtonConfig.IMAGE_DOWN));
+      button.setImage(ButtonConfig.IMAGE_INS, images.get(ButtonConfig.IMAGE_INS));
+   }
 }

=== modified file 'src/com/goldencode/p2j/ui/client/gui/theme/Theme.java'
--- src/com/goldencode/p2j/ui/client/gui/theme/Theme.java	2020-01-29 14:38:53 +0000
+++ src/com/goldencode/p2j/ui/client/gui/theme/Theme.java	2020-02-25 16:40:33 +0000
@@ -2,7 +2,7 @@
 ** Module   : Theme.java
 ** Abstract : the interface for all themes supported by FWD. 
 **
-** Copyright (c) 2017-2019, Golden Code Development Corporation.
+** Copyright (c) 2017-2020, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- ---------------------------------Description---------------------------------
 ** 001 OM  20170308 Initial version with declaration of basic renderers and getters.
@@ -26,6 +26,7 @@
 **                  changes.
 ** 017 MAG 20191011 Added ProgresBar widget draw methods. 
 ** 018 MAG 20191204 Split draw for TabSet control.
+** 019 SBI 20200225 Added new look and feel methods for the Calendar widget.
 */
 
 /*
@@ -576,6 +577,96 @@
                           int height);
    
    /**
+    * Sets DOWN arrow images for the given button.
+    * 
+    * @param    button
+    *           The given button
+    */
+   public void setDownArrowImages(ButtonGuiImpl button);
+   
+   /**
+    * Sets LEFT arrow images for the given button.
+    * 
+    * @param    button
+    *           The given button
+    */
+   public void setLeftArrowImages(ButtonGuiImpl button);
+   
+   /**
+    * Sets RIGHT arrow images for the given button.
+    * 
+    * @param    button
+    *           The given button
+    */
+   public void setRightArrowImages(ButtonGuiImpl button);
+   
+   /**
+    * Sets UP arrow images for the given button.
+    * 
+    * @param    button
+    *           The given button
+    */
+   public void setUpArrowImages(ButtonGuiImpl button);
+   
+   /**
+    * Gets the background color index for the selected day of the calendar popup.
+    * 
+    * @return   The background color index for the selected day
+    */
+   int getSelectedDayBackgroundColor();
+   
+   /**
+    * Gets the foreground color index for the selected day of the calendar popup.
+    * 
+    * @return   The foreground color index for the selected day
+    */
+   int getSelectedDayForegroundColor();
+   
+   /**
+    * Gets the background color index for the title of the calendar popup.
+    * 
+    * @return   The background color index for the title
+    */
+   int getCalendarTitleBackgroundColor();
+   
+   /**
+    * Gets the foreground color index for the title of the calendar popup.
+    * 
+    * @return   The foreground color index for the title
+    */
+   int getCalendarTitleForegroundColor();
+   
+   /**
+    * Gets the background color index for the trailing days around the current month 
+    * of the calendar popup.
+    * 
+    * @return   The background color index for the trailing days
+    */
+   int getCalendarTrailingBackgroundColor();
+   
+   /**
+    * Gets the foreground color index for the trailing days around the current month 
+    * of the calendar popup.
+    * 
+    * @return   The foreground color index for the trailing days
+    */
+   int getCalendarTrailingForegroundColor();
+   
+   /**
+    * Gets the background color index for the body of the calendar popup.
+    * 
+    * @return   The background color index for the body
+    */
+   int getCalendarBodyBackgroundColor();
+   
+   /**
+    * Gets the foreground color index for the body of the calendar popup.
+    * 
+    * @return   The foreground color index for the body
+    */
+   int getCalendarBodyForegroundColor();
+   
+   /**
     * Obtain the padding for alert boxes.
     * 
     * @return  the padding for alert boxes.

